#include	<Windows.h>
#include	<cstdio>
#include	<clocale>
#include	<cwchar>
#include	<map>
#include	<set>
#include	<string>

std::map<BYTE, std::wstring> charsets =
{
	{ ANSI_CHARSET, L"ANSI_CHARSET" },
	{ BALTIC_CHARSET, L"BALTIC_CHARSET" },
	{ CHINESEBIG5_CHARSET, L"CHINESEBIG5_CHARSET" },
	{ DEFAULT_CHARSET, L"DEFAULT_CHARSET" },
	{ EASTEUROPE_CHARSET, L"EASTEUROPE_CHARSET" },
	{ GB2312_CHARSET, L"GB2312_CHARSET" },
	{ GREEK_CHARSET, L"GREEK_CHARSET" },
	{ HANGUL_CHARSET, L"HANGUL_CHARSET" },
	{ MAC_CHARSET, L"MAC_CHARSET" },
	{ OEM_CHARSET, L"OEM_CHARSET" },
	{ RUSSIAN_CHARSET, L"RUSSIAN_CHARSET" },
	{ SHIFTJIS_CHARSET, L"SHIFTJIS_CHARSET" },
	{ SYMBOL_CHARSET, L"SYMBOL_CHARSET" },
	{ TURKISH_CHARSET, L"TURKISH_CHARSET" },
	{ VIETNAMESE_CHARSET, L"VIETNAMESE_CHARSET" },
	{ JOHAB_CHARSET, L"JOHAB_CHARSET" },
	{ ARABIC_CHARSET, L"ARABIC_CHARSET" },
	{ HEBREW_CHARSET, L"HEBREW_CHARSET" },
	{ THAI_CHARSET, L"THAI_CHARSET" },
};

int main(void)
{
	std::setlocale(LC_CTYPE, "");

	auto desktopWindow = ::GetDesktopWindow();
	auto dc = ::GetDC(desktopWindow);

	::LOGFONTW lf = { 0 };
	lf.lfCharSet = DEFAULT_CHARSET;
	::lstrcpyW(lf.lfFaceName, L"Arial");

	::EnumFontFamiliesExW(dc, &lf, [] (const LOGFONT *lpelfe, const TEXTMETRIC *lpntme, DWORD FontType, LPARAM lParam)
	{
		static std::set<BYTE> already;

		if (already.find(lpelfe->lfCharSet) != already.end())
		{
			return TRUE;
		}
		already.insert(lpelfe->lfCharSet);
		std::wprintf(L"%ls\n", charsets[lpelfe->lfCharSet].c_str());
		return TRUE;
	}, 0, 0);
	::ReleaseDC(desktopWindow, dc);

	return 0;
}
